-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
--
-- Tool name: Looping Patterns
-- Version: 1.0 build 001
-- License: GNU General Public Licence. Prohibited any use of commercial ambit.
-- Distribution: Full version
-- Compatibility: Renoise v3.2.1
-- Development date: November 2019
-- Published: November 2019
-- Locate: Spain
-- Programmer: ulneiz
--
-- Description:  Add two new keyboard commands to unselect or select the patterns for looping. For assing it manually, go to:
--                 1- Renoise:Edit/Preferences/Keys: "Pattern Sequencer:Looping Patterns:Unselect or Select a Range of Sequence"
--                 2- Renoise:Edit/Preferences/Keys: "Pattern Sequencer:Looping Patterns:Unselect or Select Current Sequence"
--
-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------


--unselect or select range of sequence
local function sel_loop_range_seq()
  local song=renoise.song()
  local trans=song.transport
  local seq_sta=trans.loop_sequence_start
  local seq_end=trans.loop_sequence_end
  local seq_idx=song.selected_sequence_index
  if (seq_sta~=0) then
    if (seq_idx>=seq_sta and seq_idx<=seq_end) then
      trans.loop_sequence_range={}
    elseif (seq_idx>seq_end) then
      trans.loop_sequence_range={seq_sta,seq_idx}
    elseif (seq_idx<seq_sta) then
      trans.loop_sequence_range={seq_idx,seq_end}
    end
  else
    trans.loop_sequence_range={seq_idx,seq_idx}
  end
end



--unselect or select current sequence index
local function sel_loop_seq()
  local song=renoise.song()
  local trans=song.transport
  local seq_idx=song.selected_sequence_index
  if (trans.loop_sequence_start~=seq_idx) then
    trans.loop_sequence_range={seq_idx,seq_idx}
  else
    trans.loop_sequence_range={}
  end
end




--register keybinding
renoise.tool():add_keybinding{
  name="Pattern Sequencer:Looping Patterns:Unselect or Select a Range of Sequence",
  invoke=sel_loop_range_seq
}

renoise.tool():add_keybinding{
  name="Pattern Sequencer:Looping Patterns:Unselect or Select Current Sequence",
  invoke=sel_loop_seq
}
